#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0

#define HEIGHT 5
#define WIDTH 8

#define START 1
#define END -3 
#define WALL -2
#define EMPTY 0
#define VISITED -1 

void init_maze(int maze[][WIDTH])
{
	maze[1][0] = WALL;
	maze[2][0] = WALL;
	maze[3][0] = WALL;
	maze[3][1] = WALL;
	maze[3][2] = WALL;
	maze[3][4] = WALL;
	maze[2][4] = WALL;
	maze[4][4] = WALL;
	maze[4][6] = END;
}

void print_maze(int maze[][WIDTH])
{
	int h, w;
	char c = '*';

	for (h = 0; h < HEIGHT; ++h)
	{
		for (w = 0; w < WIDTH; ++w)
		{
			if (maze[h][w] > 0)
				printf("%3d", maze[h][w]);
			else 
			{
				switch (maze[h][w])
				{
					case EMPTY:
						c = '_';
						break;
					case VISITED: 
						c = '_';
						break;
					case END:
						c = 'E';
						break;
					case WALL:
						c = 'W';
						break;
				}
				if (c == '*')
				{
					printf("why???\n");
				}
				printf("%3c", c);
			}
		}
		printf("\n");
	}
}

int solve(int maze[][WIDTH], int h, int w, int n)
{
	// check bounds
	if (h < 0 || h >= HEIGHT || w < 0 || w >= WIDTH)
		return FALSE;
	switch (maze[h][w])
	{
	case END:
		return TRUE;
	case EMPTY:
		maze[h][w] = n;
		if (solve(maze, h+1, w, n+1) || solve(maze, h, w+1, n+1) ||
			solve(maze, h-1, w, n+1) || solve(maze, h, w-1, n+1))
			return TRUE;
		maze[h][w] = VISITED;
	// PATH or VISITED or failed EMPTY
	default: 
		return FALSE;		
	}
}

int main()
{
	int maze[HEIGHT][WIDTH] = {EMPTY};

	init_maze(maze);
	print_maze(maze);
	
	if (solve(maze, 0, 0, 1))
	{
		printf("Solution:\n");
		print_maze(maze);
	}
	else
		printf("No solution\n");

	return 0;
}